<?xml version="1.0"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:msxsl="urn:schemas-microsoft-com:xslt"
	xmlns:msftscw="http://www.microsoft.com/windows/security/">
	
<xsl:import href="..\scwxmlloc.xsl" /> 
<xsl:include href="Vars.xsl" /> 

<!-- This file contains the security configuration log file  stylesheet -->

	<!-- output HTML -->
	<xsl:output method="html"/>
	
	<xsl:template match="Log">
		<html>
			<xsl:comment>
			  <xsl:value-of select="msftscw:InitLocVariable($UserUILanguage, '..\SCWLocStrings.xml', 'SCWLocStrings.xml', '..\MUI\', '..\')" /> 
			</xsl:comment>

			<!-- output title and CSS -->
			<head>
				<title>Security Configuration Log File</title>
				<link rel="stylesheet" type="text/css" href="../TransformFiles/View/kb.css"/>
				
				<xsl:text disable-output-escaping="yes"><![CDATA[
				<script language="JScript">
				
					function getImagePath(FileName) 
					{
						var strPath = "../TransformFiles/View/" + FileName;
						return strPath;
					}
			
					function changeImg(bHoverOver)
					{
						var ImgElement		=   null;						
						var tdElement		=   null;
						
						if ( event.srcElement.tagName == "IMG" )
						{
							tdElement	 = event.srcElement.parentElement;
							ImgElement	 = event.srcElement;
						}							
						else 
						{
							tdElement	 = event.srcElement;
							ImgElement	 = event.srcElement.firstChild;
						}							
				
						if (tdElement.className		==	"SCWLogGroupDataExpanded" ) 
						{
							if ( bHoverOver ) 
							{
								ImgElement.src				=	getImagePath("DownArrowHighLight.gif");
							}
							else 
							{
								ImgElement.src				=	getImagePath("DownArrow.gif");
							}
						}
						else
						{
							if ( bHoverOver ) 
							{
								ImgElement.src				=	getImagePath("RightArrowHighLight.gif");
							}
							else {
								ImgElement.src				=	getImagePath("RightArrow.gif");
							}
						}							
					}
					
					function toggleDisplay()
					{
					
						var tBodyElement	=	null;
						var tBodyToHide		=   null;
						var ImgElement		=   null;						
						var tdElement		=   null;
						

						if ( event.srcElement.tagName == "IMG" )
						{
							tdElement	 = event.srcElement.parentElement;
							tBodyElement = tdElement.parentElement.parentElement;
							ImgElement	 = event.srcElement;
							tBodyToHide  = tBodyElement.nextSibling;
						}							
						else 
						{
							tdElement	 = event.srcElement;
							tBodyElement = event.srcElement.parentElement.parentElement;
							ImgElement	 = event.srcElement.firstChild;
							tBodyToHide  = tBodyElement.nextSibling;
						}							
					
						if("none" == tBodyToHide.currentStyle.display)
						{
							tdElement.className			=	"SCWLogGroupDataExpanded";
							tBodyToHide.style.display	=	"block";
							ImgElement.src				=	getImagePath("DownArrow.gif");
						}
						else
						{
							tdElement.className			=	"SCWLogGroupDataCollapsed";
							tBodyToHide.style.display	=	"none";
							ImgElement.src				=	getImagePath("RightArrow.gif");    
						}   
					}
				</script>
				]]></xsl:text>
				
			</head>
			
			<table align="center" width="95%" cellspacing="0" cellpadding="0" border="0">
			<tr>
				<td class="SCWLogTitle" colspan="5">
					<xsl:value-of select="msftscw:getString('SCWPolicy/SCWLogSections/Title', '..\SCWLocStrings.xml')"/>
				</td>
			</tr>
			
			<tr>
				<td class="SCWLogHeadRow">
					<xsl:value-of select="msftscw:getString('SCWPolicy/SCWLogSections/Level', '..\SCWLocStrings.xml')"/>&#160;&#160;
					</td>
				<td class="SCWLogHeadRow"><xsl:value-of select="msftscw:getString('SCWPolicy/SCWLogSections/Time', '..\SCWLocStrings.xml')"/></td>
				<td class="SCWLogHeadRow"><xsl:value-of select="msftscw:getString('SCWPolicy/SCWLogSections/HResult', '..\SCWLocStrings.xml')"/></td>
				<td class="SCWLogHeadRow"><xsl:value-of select="msftscw:getString('SCWPolicy/SCWLogSections/Message', '..\SCWLocStrings.xml')"/></td>
				<td class="SCWLogHeadRow"><xsl:value-of select="msftscw:getString('SCWPolicy/SCWLogSections/SysMessage', '..\SCWLocStrings.xml')"/></td>
			</tr>
		
			<xsl:apply-templates />
			
			</table>			
					
		</html>
	</xsl:template>
	
	<!-- This template mateches all the level attribute inside a LogEntry-->
	
	<xsl:template match="@Level">	
	
		<xsl:choose>
			<xsl:when test="normalize-space(.) = 'Informational'">
				<img border="0">
					<xsl:attribute name="alt">
						<xsl:value-of select="msftscw:getString('SCWPolicy/SCWLogSections/Informational', '..\SCWLocStrings.xml')"/>
					</xsl:attribute>							
				
					<xsl:attribute name="src">
						<xsl:value-of select="msftscw:getImagePath('scwinfo.gif')" />
					</xsl:attribute>							
				</img>
			</xsl:when>
			<xsl:when test="normalize-space(.) = 'Warning'      ">
				<img  border="0">
					<xsl:attribute name="alt">
						<xsl:value-of select="msftscw:getString('SCWPolicy/SCWLogSections/Warning', '..\SCWLocStrings.xml')"/>
					</xsl:attribute>							
				
					<xsl:attribute name="src">
						<xsl:value-of select="msftscw:getImagePath('scwalert.gif')" />
					</xsl:attribute>							
				</img>
			</xsl:when>						
			<xsl:when test="normalize-space(.) = 'Error'        ">
				<img border="0">
					<xsl:attribute name="alt">
						<xsl:value-of select="msftscw:getString('SCWPolicy/SCWLogSections/Error', '..\SCWLocStrings.xml')"/>
					</xsl:attribute>							
				
					<xsl:attribute name="src">
						<xsl:value-of select="msftscw:getImagePath('scwerror.gif')" />
					</xsl:attribute>							
				</img>
			</xsl:when>						
			<xsl:when test="normalize-space(.) = 'Progress'        ">
				<img border="0">
					<xsl:attribute name="alt">
						<xsl:value-of select="msftscw:getString('SCWPolicy/SCWLogSections/Progress', '..\SCWLocStrings.xml')"/>
					</xsl:attribute>							
				
					<xsl:attribute name="src">
						<xsl:value-of select="msftscw:getImagePath('scwprogress.gif')" />
					</xsl:attribute>							
				</img>
			</xsl:when>						

		</xsl:choose>
	
	</xsl:template>
	
	<!-- This displays each logentry in the log file-->
	
	<xsl:template match="LogEntry">
	<xsl:variable name="LogMessage" select="normalize-space(@Message)"/>				
			<tr>
			     <xsl:if test="@Level = 'Progress'">
				<xsl:attribute name="class">SCWLogDataRowProgress</xsl:attribute>
			      </xsl:if>

				<td class="SCWLogDataRow">

				
				<xsl:apply-templates select="@Level" />
				
				</td>				
				<td class="SCWLogDataRow"><xsl:value-of select="@Time"/></td>
				<td class="SCWLogDataRow"><xsl:value-of select="@HRESULT"/></td>
				<td class="SCWLogDataMessageCol">
					<xsl:choose>
						<xsl:when test="string-length(@Message)= 0">&#160;</xsl:when>
						<xsl:otherwise><xsl:value-of select="msftscw:getMessage($LogMessage)"/></xsl:otherwise>				
					</xsl:choose>
				</td>
				<td class="SCWLogDataMessageCol">
					<xsl:choose>
						<xsl:when test="string-length(@SystemErrorMessage)= 0">&#160;</xsl:when>
						<xsl:otherwise><xsl:value-of select="@SystemErrorMessage"/></xsl:otherwise>				
					</xsl:choose>
				</td>					
			</tr>
	</xsl:template>		
	
	<xsl:template match="RuleLog/LogEntry">
	<xsl:variable name="LogMessage" select="normalize-space(@Message)"/>				
		      <xsl:if test="position()!=last()">
				<tr>
					<td class="SCWLogGroupDataRow" style="border-left:1px solid #9A999E;">
						<xsl:apply-templates select="@Level" />					
					</td>				
					<td class="SCWLogGroupDataRow"><xsl:value-of select="@Time"/></td>
					<td class="SCWLogGroupDataRow"><xsl:value-of select="@HRESULT"/></td>
					<td class="SCWLogGroupDataMessageCol">
						<xsl:choose>
							<xsl:when test="string-length(@Message)= 0">&#160;</xsl:when>
							<xsl:otherwise><xsl:value-of select="msftscw:getMessage($LogMessage)"/></xsl:otherwise>				
						</xsl:choose>
					</td>
					<td class="SCWLogGroupDataMessageCol" style="border-right:1px solid #9A999E;">
						<xsl:choose>
							<xsl:when test="string-length(@SystemErrorMessage)= 0">&#160;</xsl:when>
							<xsl:otherwise><xsl:value-of select="@SystemErrorMessage"/></xsl:otherwise>				
						</xsl:choose>
					</td>
				</tr>
			</xsl:if>
			
			<xsl:if test="position()= last()">
	
				<tr>
					<td class="SCWLogGroupDataRowLast" style="border-left:1px solid #9A999E;">
						<xsl:apply-templates select="@Level" />						
					</td>				
					<td class="SCWLogGroupDataRowLast"><xsl:value-of select="@Time"/></td>
					<td class="SCWLogGroupDataRowLast"><xsl:value-of select="@HRESULT"/></td>
					<td class="SCWLogDataMessageColLast">
						<xsl:choose>
							<xsl:when test="string-length(@Message)= 0">&#160;</xsl:when>
							<xsl:otherwise><xsl:value-of select="msftscw:getMessage($LogMessage)"/></xsl:otherwise>				
						</xsl:choose>
					</td>
					<td class="SCWLogDataMessageColLast" style="border-right:1px solid #9A999E;">
						<xsl:choose>
							<xsl:when test="string-length(@SystemErrorMessage)= 0">&#160;</xsl:when>
							<xsl:otherwise><xsl:value-of select="@SystemErrorMessage"/></xsl:otherwise>				
						</xsl:choose>
					</td>						
				</tr>
			</xsl:if>
			
			
						
	</xsl:template>		
	
	<xsl:template match="RuleLog" >
		<tbody>
			<tr id= "row">
				<td id= "column" class="SCWLogGroupDataExpanded" colspan="5" onclick="toggleDisplay();" onmouseover="changeImg(1);" onmouseout="changeImg(0);">
					<img id="img" src="DownArrow.gif"  border="0" >
						<xsl:attribute name="src">
							<xsl:value-of select="msftscw:getImagePath('DownArrow.gif')" />
						</xsl:attribute>					
					</img>						
					&#160;&#160;
					<xsl:value-of select="msftscw:getString('SCWPolicy/SCWLogSections/ExtName', '..\SCWLocStrings.xml')"/>
					<xsl:value-of select="@RuleName"/>
				</td>
			</tr>
		</tbody>

		<tbody>
			<xsl:apply-templates />				
		</tbody>
	</xsl:template>
		
	<xsl:template match="*">
	</xsl:template>
	
	<msxsl:script language="JScript" implements-prefix="msftscw"><![CDATA[
///////////////////////////////////////////////////////////////////////////////
//
// Product:     Microsoft Windows Security Configuration Wizard
//
//              Copyright © Microsoft Corporation, 2003-2004
//
// File:        LogView.xsl
//
// Contents;    Reinterprets the Microsoft.OS.Networking.IPSec Rule section
//              of the Security Policy XML.
//
///////////////////////////////////////////////////////////////////////////////

//-----------------------------------------------------------------------------
//
// Method:      getImagePath
//
// Arguments:   (string) FileName - Name of the image file 
//
// Returns:     (string) - The complete image path
//
//-----------------------------------------------------------------------------

function getImagePath(FileName) 
{
	var strPath = "../TransformFiles/View/" + FileName;
	return strPath;
}
function getMessage(strMessage) {
/*	var regExp = new RegExp("[\\]", "gi");*/
	strTemp = strMessage.replace("\\", "\\ ");
	return strTemp ;
}

]]>
</msxsl:script>
	
</xsl:stylesheet>
	